#include <stdio.h>
#include <time.h>

#define NUMCAMPOS 20
#define NUMDB 2

FILE *pfdb[NUMDB];
char nombredb[150*NUMDB];
unsigned char cabecera[35];
unsigned char  *cabememo[NUMDB];
unsigned int totalcampos[NUMDB],primercampo[NUMDB];
unsigned int tamaregs[NUMDB],numreg[NUMDB];
long tamano[NUMDB];
char tamareg[1000][NUMDB];



char VARI[200],buffer[1024];
/*unsigned char *ppv,*ppv1; */
/* Variable CAMPO es el campo donde en la funcion de busqueda encuentra la cadena */
int CAMPO;



int opendb(char *nombre,int numdb);
int closedb(int numdb);
void verficha(int num,int numdb);
int compara(int numdb,int num,int campo,char *texto);
int SearchAll(int numdb,int n,char *texto);
void appedb(int numdb);
void deldb(int num,int numdb);
void nodeldb(int num,int numdb);
void packdb(int numdb);
char verdeldb(int num,int numdb);
void ordenardb(int num,int numdb,int forma);
void MinuMayu(int numdb);
int makedb(int campo,char tipo,int tamano,int decimales, char *nombre);
void update(int numdb);
int checkdb(int numdb,int n);


/* Chequea una base de datos */
/* n=0 chequea la base de datos y devuelve 0 si no hay error */
/* devuelve:
			1 si el numero de registros son mas que el tamao de la base de datos
			2 el tamao de la base de datos es mayor al numero de registros
*/
/* n=1 Ajusta el numero de fichas al tamao de la base de datos */
int checkdb(int numdb,int n)
{
 long z,zz;
 char *ppv;
  	z=tamano[numdb]-primercampo[numdb];
	zz=tamaregs[numdb]*numreg[numdb];
	if(n==0)
		{
		 g_print("Chequeo %d error si es diferente de 0",z-zz);
		 if(z-zz==0)return(0);
		 if(zz>z) return(1);
		 if(zz<z) return(2);
		}
	 else
		{
		 if(n==1)
		 	{
			 if(zz>z)
				 	{
					 numreg[numdb]=z/tamaregs[numdb];
					 ppv=cabememo[numdb]+4; *ppv=0x00FF&numreg[numdb];
					 ppv++;	*ppv=0x00FF&(numreg[numdb]>>8);
					 fseek(pfdb[numdb],4,0);
					 fwrite(cabememo[numdb]+4,2,1,pfdb[numdb]);
					}
			}
		}
}

void update(int numdb)
{
 unsigned char ano,mes,dia;
 time_t tiempo;
 struct  tm *ptime;
 static marca=0;
 	if(marca==0)
		{
		 marca=1;
		 tiempo=time(NULL);
		 ptime=localtime(&tiempo);
		 ano=(*ptime).tm_year-100;
		 mes=(*ptime).tm_mon+1;
		 dia=(*ptime).tm_mday;
		 g_print("Update Ao=%d Mes=%d Dia=%d\n",ano,mes,dia);
		 fseek(pfdb[numdb],1,0);
		 fputc(ano,pfdb[numdb]);
		 fputc(mes,pfdb[numdb]);
		 fputc(dia,pfdb[numdb]);
		}
}
/*crea  base de datos*/
/*Cuando se quiere crear, colocar en campo=-1,
 en tamano el numero de campos,
 y en el nombre el nombre de la base de datos */
int makedb(int campo,char tipo,int tamano,int decimales, char *nombre)
{
int z,num;
FILE *pf;
char *p;
static char campox[11][NUMCAMPOS];
static char tipox[NUMCAMPOS];
static unsigned int tamanox[NUMCAMPOS];
static unsigned int decimalesx[NUMCAMPOS];
unsigned int zz,z1;
char VARI[80];

	if(campo!=-1)
		{
		 if(campo<NUMCAMPOS)
			{
			 p=nombre;
			 for(zz=0;zz<11&&*p!=0;zz++,p++){campox[zz][campo]=*p; g_print("%c",*p);}
			 tipox[campo]=tipo;
			 tamanox[campo]=tamano;
			 decimalesx[campo]=decimales;
			}
		}
		else
		{
			num=tamano;
		 	if((pf=fopen(nombre,"w+b"))==NULL) return(-1);
			/*----CREACION DE LA BASE DE DATOS----*/
			g_print("\nNumero de campos= %d ",num);
			putc(3,pf);
			/* fecha */
			putc(0,pf);
			putc(0,pf);
			putc(0,pf);
			/* numero de fichas por defecto 1 */
			putc(1,pf);
			putc(0,pf);
			putc(0,pf);
			putc(0,pf);
			/* direccin de primer campo */
			zz=(num+1)*32+1;
			putc((zz&0x00ff),pf);
			putc(((zz>>8)&0x00ff),pf);
			/* tamao de ficha */
			zz=1;
			for(z=0;z<num;z++){zz+=tamanox[z]+decimalesx[z];	}
			z1=zz;
			putc((zz&0x00ff),pf);
			putc(((zz>>8)&0x00ff),pf);
			/* 20 bytes con cero */
			for(z=0;z<20;z++)putc(0,pf);
			/* cabecera de ficha, tamao 32 */
			for(zz=0;zz<num;zz++)
			{
			  /* nombre 10 caracteres y un cero */
			  for(z=0;z<11;z++)putc(campox[z][zz],pf);
			  /* tipo c/n/d/l */
			  putc(tipox[zz],pf);
			  /* ----xxxx---- */
			  putc(0,pf);
			  putc(0,pf);
			  putc(0,pf);
			  putc(0,pf);
			  /* tamao de la ficha */
			  putc(tamanox[zz],pf);
			  /* numero de decimales */
			  putc(decimalesx[zz],pf);
			  /* 14 bytes reservados */
			  for(z=0;z<14;z++)putc(0,pf);
			}
			/* finaliza con un 13 */
			putc(13,pf);
			/* crea la primer ficha en blanco */
			for(z=0;z<z1;z++)putc(32,pf);
			/* termina con el caracter 26 */
			putc(26,pf);
			fclose(pf);
		}
	return(0);
}

int SearchAll(int numdb,int n,char *texto)
{
int z,zz;
	for(z=n;z<numreg[numdb];z++)
		{
		 for(zz=0;zz<totalcampos[numdb];zz++)
		 	{
			 if(1==compara(numdb,z,zz,texto))
				 {
				  CAMPO=zz;
				  return(z);
				 }
			}
		}
return(-1);
}

int SearchCampo(int numdb,int n,int campo,char *texto)
{
int z,zz;
	for(z=n;z<numreg[numdb];z++)
		{
			 if(1==compara(numdb,z,campo,texto))
				 {
				  return(z);
				 }
		}
return(-1);
}


/* ----- Compara texto en ficha y campo, devuelve 1 si = ----- */
int compara(int numdb,int num,int campo,char *texto)
{
int z,zz;
long indi;
unsigned char *ppv1;
	if(pfdb[numdb]==0)goto fin;
	if(num<0||num>=numreg[numdb])goto fin;
	z=0;
	for(zz=0;zz<campo;zz++)z+=tamareg[zz][numdb];
	indi=primercampo[numdb]+num*(tamaregs[numdb]);
	fseek(pfdb[numdb],indi+z,0);

	 z=campo;
	 fread(buffer,1,tamareg[z][numdb],pfdb[numdb]);
	 buffer[tamareg[z][numdb]]=0;
	 ppv1=cabememo[numdb]+z*32+43;
	 if(*ppv1=='D')
			{
             strncpy(buffer+20,buffer,10);
			 strncpy(buffer,buffer+26,2);
			 buffer[2]='/';
			 strncpy(buffer+3,buffer+24,2);
			 buffer[5]='/';
			 strncpy(buffer+6,buffer+20,4);
			 buffer[10]=0;
			}
	if(NULL!=(char *)strstr(buffer,texto)) return(1); else return(0);
fin:
	return(0);
}


/* ---- Cierra base de datos ---- */

int closedb(int numdb)
{
	if(pfdb[numdb]!=0)
		{
		 fclose(pfdb[numdb]);
         free(cabememo[numdb]);
		 pfdb[numdb]=0;
		 cabememo[numdb]=0;
		}
}

/*---- Abre un base de datos -----*/
int opendb(char *nombre,int numdb)
{
 unsigned int i,z;
	if((pfdb[numdb]=fopen(nombre,"r+b"))==NULL) return(-1);
	strncpy(nombredb+numdb*80,nombre,80);
    fseek(pfdb[numdb],0,2);
    tamano[numdb]=ftell(pfdb[numdb]);
	fseek(pfdb[numdb],0,0);	fread(cabecera,1,32,pfdb[numdb]);
	numreg[numdb]=cabecera[4]+cabecera[5]*256;
/*	printf("numero de fichas %d\n",numreg[numdb]); */
	totalcampos[numdb]=0; i=32; tamaregs[numdb]=0;

volver:
	fseek(pfdb[numdb],i,0);
	fread(cabecera,1,34,pfdb[numdb]);
	z=cabecera[16];
	tamaregs[numdb]= tamaregs[numdb]+z;
	tamareg[totalcampos[numdb]][numdb]=z;
	i+=32;	totalcampos[numdb]++;
	if(cabecera[32]!=13 ) goto volver;
	tamaregs[numdb]++;
	primercampo[numdb]=i+2;
	if(cabecera[33]==0)primercampo[numdb]++;
	if(NULL==(cabememo[numdb]=(char *)malloc(primercampo[numdb]))) error(8);
	fseek(pfdb[numdb],0,0);
	fread(cabememo[numdb],primercampo[numdb],1,pfdb[numdb]);
	strncpy(VARI,nombredb,40);g_print("%s\n",VARI);
	sprintf(VARI,"Nume. campos=%d  dir.1.campo=%d \nTamao base=%d fichas=%d TamaFichas=%d",totalcampos[0],primercampo[0],tamano[0],numreg[numdb],tamaregs[numdb]);	g_print("%s\n",VARI);
}

/* ---- Inserta una ficha mas ---- */
void appedb(int numdb)
{
long indi;
unsigned int z;
unsigned char *ppv;
	update(numdb);
	fseek(pfdb[numdb],0,2);
	z=tamaregs[numdb]+1;
	for(;z>0;z--)putc(0,pfdb[numdb]);
	putc(26,pfdb[numdb]);
	numreg[numdb]++;
	tamano[numdb]+=tamaregs[numdb];
	ppv=cabememo[numdb]+4; *ppv=0x00FF&numreg[numdb];
	ppv++;	*ppv=0x00FF&(numreg[numdb]>>8);
	fseek(pfdb[numdb],4,0);
	fwrite(cabememo[numdb]+4,2,1,pfdb[numdb]);

}


/* ---- Marca la ficha con * de borrado ---- */
void deldb(int num,int numdb)
{
long indi;
	update(numdb);
	if(num<0||num>=numreg[numdb])goto fin;
	indi=primercampo[numdb]+num*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	fputc(42,pfdb[numdb]);
fin:
;
}
/* ---- Elimina marca de borrado ---- */
void nodeldb(int num,int numdb)
{
long indi;
	update(numdb);
	if(num<0||num>=numreg[numdb])goto fin;
	indi=primercampo[numdb]+num*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	fputc(32,pfdb[numdb]);
fin:
;
}
/* ---- Borra todas las fichas marcadas con * ---- */
void packdb(int numdb)
{
long indi;
unsigned int z,zz,conta;
unsigned char *ppv,*ppv1;
	update(numdb);
	if(NULL==(ppv=(char *)malloc(tamano[numdb]))){ error(8); goto fin;}
	fseek(pfdb[numdb],0,0);	fread(ppv,tamano[numdb],1,pfdb[numdb]);
	printf("Borrando fichas marcadas\n");

	conta=0; zz=numreg[numdb];
	for(z=0;z<zz;z++)
		{
		 indi=primercampo[numdb]+z*(tamaregs[numdb])-1;
		 ppv1=ppv+indi;
		 if(*ppv1==42)
			{
			 memcpy(ppv1,ppv1+tamaregs[numdb],tamaregs[numdb]*(numreg[numdb]+1));
			 conta++; zz--; z--;
			}
		}
	if(numreg[numdb]==conta)
		{
		 conta--;
		 ppv1=ppv+primercampo[numdb]-1;
		 for(z=0;z<tamaregs[numdb];z++,ppv1++){*ppv1=32;}
		 *ppv1=26;
		}
	tamano[numdb]-=conta*tamaregs[numdb];
	numreg[numdb]-=conta;
	ppv1=ppv+4; *ppv1=0x00FF&numreg[numdb];
	ppv1++;	*ppv1=0x00FF&(numreg[numdb]>>8);
	printf("borradas %d fichas \n",conta);
	closedb(numdb);
	strncpy(VARI,nombredb+80*numdb,80); VARI[79]=0;
	if((pfdb[numdb]=fopen(VARI,"w+b"))==NULL){error(2); goto fin1;}
	fseek(pfdb[numdb],0,0); fwrite(ppv,tamano[numdb],1,pfdb[numdb]);
	fclose(pfdb[numdb]);
    if(-1==opendb(VARI,numdb))error(2);
fin1:

	free(ppv);
fin:
;
}
/* ---- Ve el estado de las fichas ---- */
char verdeldb(int num,int numdb)
{
 long indi;
	if(num<0||num>=numreg[numdb])return(-1);
	indi=primercampo[numdb]+num*(tamaregs[numdb])-1;
	fseek(pfdb[numdb],indi,0);
	return(fgetc(pfdb[numdb]));
}


/* -ordena una base de datos por el campo num -*/
/* -forma 0=ascendente , 1=descendente- */
void ordenardb(int num,int numdb,int forma)
{
long indi;
unsigned int z,zz,ta,tipo,z1;
unsigned int x,y,yy;
unsigned char *ppv,*ppv0,*ppv1,*ppv2;
long num1,num2;
	update(numdb);
	ppv1=cabememo[numdb]+num*32+43;
	if(*ppv1=='N'){tipo=1; printf("Ordenacion numerico\n");} else printf("Ordenacion alfanumerica\n");
	ta=tamaregs[numdb];

	if(NULL==(ppv0=(char *)malloc(ta))){ error(8); goto fin;}
	if(NULL==(ppv=(char *)malloc(tamano[numdb]))){ error(8); goto fin0;}
	fseek(pfdb[numdb],0,0);	fread(ppv,tamano[numdb],1,pfdb[numdb]);
	printf("Campo %d  - Tipo=%d (0=ascendente-1=descendente)\n",num,forma);

	z=0; z1=0;
	for(zz=0;zz<num;zz++)z+=tamareg[zz][numdb];
	zz=numreg[numdb];
	for(x=0;x<zz;x++)
		{
		 z1++;
		 if(z1>500) { z1=0; printf("Ordenando ficha %d\n",x); }
		 ppv1=ppv+primercampo[numdb]+x*ta+z;
		 for(y=0;y<zz;y++)
		 	{
			 ppv2=ppv+primercampo[numdb]+y*ta+z;
			 if(tipo==1)
				 {
					 yy=tamareg[num][numdb];
					 memcpy(VARI,ppv1,yy); VARI[yy]=0; num1=atol(VARI);
					 memcpy(VARI,ppv2,yy); VARI[yy]=0; num2=atol(VARI);
					 if(forma==0)
						{
					 	 if(num1<num2)
				 				{
							 	 memcpy(ppv0,ppv2-z,ta);
							 	 memcpy(ppv2-z,ppv1-z,ta);
								 memcpy(ppv1-z,ppv0,ta);
								}
						}
						else
						{
						 if(num1>num2)
				 				{
							 	 memcpy(ppv0,ppv2-z,ta);
							 	 memcpy(ppv2-z,ppv1-z,ta);
								 memcpy(ppv1-z,ppv0,ta);
								}
						}

				 }
				else
				 {
				  if(forma==0)
				 	{
				  	if(0>memcmp(ppv1,ppv2,tamareg[num][numdb]))
				 		{
							memcpy(ppv0,ppv2-z,ta);
							memcpy(ppv2-z,ppv1-z,ta);
							memcpy(ppv1-z,ppv0,ta);
						}
					}
					else
					{
					 if(0<memcmp(ppv1,ppv2,tamareg[num][numdb]))
				 		{
							memcpy(ppv0,ppv2-z,ta);
							memcpy(ppv2-z,ppv1-z,ta);
							memcpy(ppv1-z,ppv0,ta);
						}
					}
				 }
			}
		}

	fseek(pfdb[numdb],0,0);	fwrite(ppv,tamano[numdb],1,pfdb[numdb]);
fin1:
	free(ppv);
fin0:
	free(ppv0);
fin:
;
}


